<script setup>
import { Icon } from '@iconify/vue'
import { useBlocStore } from '@/store/bloc'
import { ref, onMounted } from 'vue'

const blocStore = useBlocStore()
const newBlocName = ref('')

const prop = defineProps({
  bid: {
    type: String,
    required: true
  }
})

const emit = defineEmits([
  'event-confirm'
])

onMounted(() => {
  let renameInput = document.querySelector('#rename-input')
  renameInput.focus()
})

const handleConfirm = () => {
  if (newBlocName.value.trim() !== '') {
    blocStore.rename(prop.bid, newBlocName.value)
  }
  emit('event-confirm')
}

const handleEnterPressed = (event) => {
  if (event.key === 'Enter') {
    handleConfirm()
  }
}
</script>

<template>
  <div class="file-modal-content-rename" @keyup="handleEnterPressed">
    <input
      id="rename-input"
      v-model="newBlocName"
      class="button-base"
      type="text"
      placeholder="Rename"
      autocomplete="off"
      autofocus
    >
    <div class="file-modal-content-rename__actions">
      <button
        class="button-base"
        :class="{'button-primary': newBlocName.trim() !== ''}"
        @click="handleConfirm"
      >
        {{ newBlocName.trim() === '' ? 'Cancel' : 'Confirm' }}
        <Icon v-show="newBlocName.trim() === ''" icon="mdi:cancel" width="16px" height="16px" />
        <Icon v-show="newBlocName.trim() !== ''" icon="mdi:check" width="16px" height="16px" />
      </button>
    </div>
  </div>
</template>

<style lang="scss" scoped>
  .file-modal-content-rename {
    display: flex;
    flex-direction: column;
    gap: 1rem;
    padding: 6px 1rem;
    input {
      background-color: #161b22;
    }
    &__actions {
      display: flex;
      align-items: center;
      flex-direction: row-reverse;
    }
  }
</style>
